# all the imports
import os
import sqlite3

from flask import Flask
from flask_mail import Mail
from flask_security import Security
    
# create application
app = Flask(__name__)#, static_folder="static") #static_url_path="static", 
app.config.from_object(__name__)
basedir = os.path.abspath(os.path.dirname(__file__))

# Load default config and override config from an environment variable
app.config.update(dict(
    #DATABASE=os.path.join(app.root_path, 'flaskr.db'),
    DEBUG=True,
    SECRET_KEY='development key',
    USERNAME='admin',
    PASSWORD='default',
    # Create dummy secrey key so we can use sessions
    DATABASE_FILE=os.path.join(basedir, 'app.db'),
    DATABASE='app.db',
    SQLALCHEMY_DATABASE_URI='sqlite:///' + os.path.join(basedir, 'app.db'),
    SQLALCHEMY_MIGRATE_REPO=os.path.join(basedir, 'db_repository'),
    SQLALCHEMY_ECHO=True,
    SECURITY_CONFIRMABLE=True, # for flask-security features
    SECURITY_REGISTERABLE=True, # for flask-security features
    SECURITY_RECOVERABLE=True, # for flask-security features
    SECURITY_TRACKABLE=True, # for flask-security features
    SECURITY_CHANGEABLE=True,
    SECURITY_USER_IDENTITY_ATTRIBUTES=['email','username'],
    MAIL_SERVER = 'mail.privateemail.com',
    MAIL_PORT = 465,
    MAIL_USE_SSL = True,
    MAIL_USERNAME = 'info@cypressboat.co.uk',
    MAIL_PASSWORD = 'Bluesky518',
    DO_PAGINATE_ITEMS = 8,
    # uploads:
    UPLOADED_IMAGE_FOLDER = "/var/www/CypressBoat/CypressBoat/static/uploadedfiles/images/",
    UPLOADED_IMAGE_URL = "/static/uploadedfiles/images/",
    USER_DEFAULT_UPLOAD_QUOTA = 20000000 # default 20MB upload quota
))



app.config.from_envvar('FLASKR_SETTINGS', silent=True)

# Create admin and empty database if required
import CypressBoat.Admin as Admin
Admin.BuildEmptyDB(app)
admin = Admin.BuildAdmin(app)
mail = Mail(app)

from CypressBoat import Views, Models, Forms
security = Security(app, Admin.user_datastore, register_form=Forms.ExtendedRegisterForm, confirm_register_form=Forms.ExtendedConfirmRegisterForm, login_form=Forms.ExtendedLoginForm)

if __name__ == '__main__':
    app.run(debug=True)

